/**
 * @(#)KimhoBoard.java        2.00 2002/05/26
 * 
 * Copyright (C)2002-2003 http://www.kimho.pe.kr 
 * All rights reserved. 
 */ 

/** 
 * <p> 
 * kimhoboard v2.0  Ŭ̴. 
 * </p> 
 * 
 * <p> 
 * The rights of this class is reserved by http://www.kimho.pe.kr
 * </p> 
 *
 *
 * @author  Ho Kim
 * @version 2.0 
 *
 */ 

package kr.pe.kimho.board;

import java.sql.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.text.*;
import kr.pe.kimho.conn.*;

public class KimhoBoard extends DBConn implements KimhoBoardInf {

    protected String branch = "L";
    protected String print = "";
    protected String table = ""; // ̺ 
    protected StringBuffer sbf = new StringBuffer("");
    protected String errMsg = "";
    protected HttpServletRequest req = null;
    protected HttpSession ses = null;

	protected int		b_id=0;
	protected String	b_name = "";
	protected String	b_mail = "";
	protected String	b_title = "";
	protected String	b_content = "";
	protected String	b_date = "";
	protected int		b_view = 0;
	protected String	b_pwd = "";
    protected String	mailtoyou = "";

	protected int b_ref = 0;
    protected int maxref = 0;
	protected int b_relevel = 0;
	protected int b_restep = 0;
	protected String b_url = "";
	protected String b_html = "";
	protected String b_filename = "";
	protected String b_filesize = "0";
    private String re="";
    private String now="";
    private String newicon="";

    private String list_head = "";
    private String list_main = "";
    private String list_paging = "";
    private String view_main = "";
    private String view_tail = "";

    private String msg = "";
    private String fileyn="N";

    private Hashtable h = new Hashtable();

    private String skinPath = "C:\\Program Files\\Apache Tomcat 4.0\\webapps\\kimhoboard2.0\\skin\\default\\";
    private String pageSize = "10";
    private String pageBlock = "5";
    private String adminPwd = "00000000";
    private String uploadPath = "C:\\Program Files\\Apache Tomcat 4.0\\webapps\\kimhoboard2.0\\upload";
    private String fileupload = "N";
    private String viewList = "N";

    /* SQL  */
    protected String SEL_MAX_BID = "";
    protected String UPD_REPLY = "";
    protected String INS_DATA = "";
    protected String INS_DATA_ORACLE = "";
    protected String SEL_LIST = "";
    protected String SEL_LIST_ORACLE = "";
    protected String SEL_DATA = "";
    protected String SEL_DATA_ORACLE = "";
    protected String SEL_VIEWLIST = "";
    protected String SEL_VIEWLIST_ORACLE = "";
    protected String UPD_BVIEW = "";
    protected String UPD_DATA = ""; 
    protected String DEL_DATA = "";

    /**  */
    public KimhoBoard() {
        setProperties();
        try {
            dbConn();
        } catch (SQLException sqle) {
            System.out.println("DB ᵵ  ߻߽ϴ.");
            release();
        }
    }

    /** properties Ѵ */
    public void setProperties() {
        InputStream is = getClass().getResourceAsStream("/config/config.properties");
		Properties confProps = new Properties();
        try {
            confProps.load(is);
        }
        catch (Exception e) {
            System.err.println("properties  ã  ϴ. " +
                "config.properties  Ŭн ȮϽñ ٶϴ.");
            return;
        }
        skinPath = confProps.getProperty("skinPath","C:\\Program Files\\Apache Tomcat 4.0\\webapps\\kimhoboard2.0\\skin\\default\\");
        pageSize = confProps.getProperty("pageSize", "10");
        pageBlock = confProps.getProperty("pageBlock", "5");
        adminPwd = confProps.getProperty("adminPwd", "00000000");
        uploadPath = confProps.getProperty("uploadPath", "C:\\Program Files\\Apache Tomcat 4.0\\webapps\\kimhoboard2.0\\upload");
        fileupload = confProps.getProperty("fileupload", "N");
        viewList = confProps.getProperty("viewList", "N");
    }

    /** String   ´ */
    public String getPrint(HttpServletRequest request,HttpSession session) {
        try {
            req = request;
            ses = session;
            branch = getParam("branch");
            table = getParam("table");

            setSQL(table);

            if(branch.equals("") || branch.charAt(0) == 'L') {
                print = getList(getParam("mypage"));
            } else if(branch.charAt(0) == 'W') {
                print = getWrite();
            } else if(branch.charAt(0) == 'V') {
                print = getView();
            } else if(branch.charAt(0) == 'A') {
                print = getAdmin();
            } else print = getList(getParam("mypage"));
        } catch (KimhoBoardException kbe) {
            return kbe.toString();
        } catch (Exception e) {
            return "KimhoBoard  ߻߽ϴ.:"+e.toString();
        } finally {
            try {
                freeConn();
                return print;
            } catch (SQLException sqle) {
                release();
                errMsg = "Ŀؼ ݳ  ߻߽ϴ :"+sqle;
                return errMsg;
            }
        }
    }

    public void setSQL(String table) {
        /**  ̺ b_id b_ref ִ밪 Ѵ */
        SEL_MAX_BID = "SELECT MAX(B_ID),MAX(B_REF) FROM "+table;
        /** 亯 ̸  Į ܰ踦 ƮѴ */
        UPD_REPLY = "UPDATE "+table+" SET B_RESTEP=B_RESTEP+1 WHERE B_REF=? AND B_RESTEP > ?";
        /**  Ѵ.*/
        INS_DATA = "INSERT INTO "+table+"(B_ID,B_NAME,B_MAIL,B_TITLE,B_CONTENT,B_DATE,B_PWD,B_VIEW,B_REF,B_RELEVEL,B_RESTEP,B_URL,B_HTML,B_FILENAME,B_FILESIZE) "+"\n"
                        + "VALUES(?,?,?,?,?,NOW(),?,0,?,?,?,?,?,?,?)";
        /**  Ѵ.(Ŭ)*/
        INS_DATA_ORACLE = "INSERT INTO "+table+"(B_ID,B_NAME,B_MAIL,B_TITLE,B_CONTENT,B_DATE,B_PWD,B_VIEW,B_REF,B_RELEVEL,B_RESTEP,B_URL,B_HTML,B_FILENAME,B_FILESIZE) "+"\n"
                        + "VALUES(?,?,?,?,?,sysdate,?,0,?,?,?,?,?,?,?)";
        /** ۸ ´ */
        SEL_LIST = "SELECT B_ID,B_NAME,B_MAIL,B_TITLE,B_CONTENT,DATE_FORMAT(B_DATE,'%Y-%m-%d') B_DATE,B_VIEW,B_PWD,B_REF,B_RELEVEL,B_RESTEP,B_URL,B_HTML,B_FILENAME,B_FILESIZE FROM "+table+" ORDER BY B_REF DESC, B_RESTEP ASC";
        /** ۸ ´ (Ŭ)*/
        SEL_LIST_ORACLE = "SELECT B_ID,B_NAME,B_MAIL,B_TITLE,B_CONTENT,TO_CHAR(B_DATE,'yyyy-mm-dd') B_DATE,B_VIEW,B_PWD,B_REF,B_RELEVEL,B_RESTEP,B_URL,B_HTML,B_FILENAME,B_FILESIZE FROM "+table+" ORDER BY B_REF DESC, B_RESTEP ASC";
        /** ش ̵ ͸ ´. */
        SEL_DATA = "SELECT B_ID,B_NAME,B_MAIL,B_TITLE,B_CONTENT,B_DATE,B_VIEW,B_PWD,B_REF,B_RELEVEL,B_RESTEP,B_URL,B_HTML,B_FILENAME,B_FILESIZE FROM "+table+" WHERE B_ID = ?";
        /** ش ̵ ͸ ´.(Ŭ) */
        SEL_DATA_ORACLE = "SELECT B_ID,B_NAME,B_MAIL,B_TITLE,B_CONTENT,TO_CHAR(B_DATE,'yyyy-mm-dd hh24:mi:ss') B_DATE,B_VIEW,B_PWD,B_REF,B_RELEVEL,B_RESTEP,B_URL,B_HTML,B_FILENAME,B_FILESIZE FROM "+table+" WHERE B_ID = ?";
        /** ۺ ñ   */
        SEL_VIEWLIST = "SELECT B_ID,B_NAME,B_MAIL,B_TITLE,B_CONTENT,DATE_FORMAT(B_DATE,'%Y-%m-%d') B_DATE,B_VIEW,B_PWD,B_REF,B_RELEVEL,B_RESTEP,B_URL,B_HTML,B_FILENAME,B_FILESIZE FROM "+table+" WHERE B_REF = ?  ORDER BY B_REF DESC, B_RESTEP ASC";
        /** ۺ ñ   (Ŭ)*/
        SEL_VIEWLIST_ORACLE = "SELECT B_ID,B_NAME,B_MAIL,B_TITLE,B_CONTENT,TO_CHAR(B_DATE,'yyyy-mm-dd hh24:mi:ss') B_DATE,B_VIEW,B_PWD,B_REF,B_RELEVEL,B_RESTEP,B_URL,B_HTML,B_FILENAME,B_FILESIZE FROM "+table+" WHERE B_REF = ?  ORDER BY B_REF DESC, B_RESTEP ASC";
        /** ȸ 1 Ų */
        UPD_BVIEW = "UPDATE "+table+" SET B_VIEW=B_VIEW+1 WHERE B_ID = ?";
        /**   */
        UPD_DATA = "UPDATE "+table
                            + " SET B_NAME=?,"
                                + " B_MAIL=?,"
                                + " B_TITLE=?,"
                                + " B_CONTENT=?,"
                                + " B_PWD=?,"
                                + " B_URL=?,"
                                + " B_HTML=?,"
                                + " B_FILENAME=?,"
                                + " B_FILESIZE=?"
                            + " WHERE B_ID=?";
        /**   */
        DEL_DATA = "DELETE FROM "+table+" WHERE B_ID = ?";
    }

    /**  α */
    public String getAdmin() throws KimhoBoardException {
        try {
            if(getParam("ACT").equals("LOGIN")) {
                print = getSkin(skinPath + "admin_form.txt");
                print = change_Code(print,"[PRINT_TABLE]",table);
            } else if(getParam("ACT").equals("SETADMIN")){
                if(getParam("adminPwd").equals(adminPwd)) {
                    ses.setAttribute("admin",ses.getId());
                    //print = getList("");
					print = goList("");
                } else {
                    print = backScript(" н尡 ġ ʽϴ.");
                }
            } else if(getParam("ACT").equals("LOGOUT")) {
                ses.setAttribute("admin","");
                //print = getList("");
				print = goList("");
            } 
            return print;
        } catch (Exception e) {
            throw new KimhoBoardException(" 忡  ߻߽ϴ. :"+e.toString());
        }
    }

    /* ,, μ */
    public String getWrite() throws KimhoBoardException {
        try {
            if(getParam("WACT").equals("")) {
                print = getSkin(skinPath + "write_form.txt");
                print = change_Code(print,"[PRINT_TABLE]",table);
                print = change_Code(print,"[PRINT_BNAME]","");
                print = change_Code(print,"[PRINT_BMAIL]","");
                print = change_Code(print,"[PRINT_BURL]","http://");
                print = change_Code(print,"[PRINT_BTITLE]","");
                print = change_Code(print,"[PRINT_BCONTENT]","");
                print = change_Code(print,"[PRINT_BID]","");
                print = change_Code(print,"[PRINT_BPWD]","");
                print = change_Code(print,"[PRINT_BREF]","0");
                print = change_Code(print,"[PRINT_BRELEVEL]","0");
                print = change_Code(print,"[PRINT_BRESTEP]","0");
                print = change_Code(print,"[PRINT_WACT]","INSERT");
                print = change_Code(print,"[PRINT_MYPAGE]",getParam("mypage"));
                print = change_Code(print,"[PRINT_WARNFILE]","");
                if(fileupload.equals("Y")) {
                    print = change_Code(print,"[PRINT_FILEYN]","<input type=hidden name='uploadbox' value='Y'> ÷");
                    print = change_Code(print,"[PRINT_FILEFORM]","<input type='file' class='box' name='file1' size='25'>");
                } else {
                    print = change_Code(print,"[PRINT_FILEYN]","<input type=hidden name='uploadbox' value='N'>");
                    print = change_Code(print,"[PRINT_FILEFORM]","");
                }
                print = change_Code(print,"[PRINT_BUTTON]","<a href='javascript:on_writebtn_click();'><img border=0 height=20 src='skin/images/save.gif' width=60></a>");
            } else if(getParam("WACT").equals("INSERT")) {
                fileyn=getParam("fileyn");
                setInsert();
                //print = getList(getParam("mypage")); // Ϻ ̵
				print = goList(getParam("mypage"));
            } else if(getParam("WACT").equals("R")) {
                preparedStmt(SEL_DATA);
                pstmt.setString(1,getParam("b_id"));
                pExecuteQuery();
                if(next()) {
                    b_title = getString("B_TITLE");
                    b_content = "\n\n\n==========================================================\n"
                            + "\t  '"+getString("B_NAME")+"'Բ  Դϴ.\n"
                            + "==========================================================\n"
                            + getString("B_CONTENT");
                    b_id = getInt("B_ID");
                    b_ref = getInt("B_REF");
                    b_relevel = getInt("B_RELEVEL");
                    b_restep = getInt("B_RESTEP");
                }
                print = getSkin(skinPath + "write_form.txt");
                print = change_Code(print,"[PRINT_TABLE]",table);
                print = change_Code(print,"[PRINT_BNAME]","");
                print = change_Code(print,"[PRINT_BMAIL]","");
                print = change_Code(print,"[PRINT_BURL]","http://");
                print = change_Code(print,"[PRINT_BTITLE]",b_title);
                print = change_Code(print,"[PRINT_BCONTENT]",b_content);
                print = change_Code(print,"[PRINT_BID]",""+b_id);  
                print = change_Code(print,"[PRINT_BPWD]","");
                print = change_Code(print,"[PRINT_BREF]",""+b_ref);
                print = change_Code(print,"[PRINT_BRELEVEL]",""+b_relevel);
                print = change_Code(print,"[PRINT_BRESTEP]",""+b_restep);
                print = change_Code(print,"[PRINT_MYPAGE]",getParam("mypage"));
                print = change_Code(print,"[PRINT_WARNFILE]","");
                if(fileupload.equals("Y")) {
                    print = change_Code(print,"[PRINT_FILEYN]","<input type=hidden name='uploadbox' value='Y'> ÷");
                    print = change_Code(print,"[PRINT_FILEFORM]","<input type='file' class='box' name='file1' size='25'>");
                } else {
                    print = change_Code(print,"[PRINT_FILEYN]","<input type=hidden name='uploadbox' value='N'>");
                    print = change_Code(print,"[PRINT_FILEFORM]","");
                }
                print = change_Code(print,"[PRINT_BUTTON]","<a href='javascript:on_writebtn_click();'><img border=0 height=20 src='skin/images/save.gif' width=60></a>");
            } else if(getParam("WACT").equals("E") && !isAdmin()) {
                print = getSkin(skinPath + "pwd_confirm.txt");
                print = change_Code(print,"[PRINT_TABLE]",table);
                print = change_Code(print,"[PRINT_BID]",getParam("b_id"));
                print = change_Code(print,"[PRINT_WACT]","EE");
                print = change_Code(print,"[PRINT_MYPAGE]",getParam("mypage"));
            } else if(getParam("WACT").equals("EE") || 
                    (getParam("WACT").equals("E") && isAdmin()) ||
                        (getParam("WACT").equals("EE") && getParam("password").equals(adminPwd))) {
                preparedStmt(SEL_DATA); 
                pstmt.setString(1,getParam("b_id"));
                pExecuteQuery();
                if(next()) {
                    b_pwd = getString("b_pwd");
                    if(b_pwd.equals(getParam("password")) || getParam("password").equals(adminPwd) || isAdmin()) {
                        b_name = getString("B_NAME");
                        b_mail = getString("B_MAIL");
                        b_title = getString("B_TITLE");
                        b_content = getString("B_CONTENT");
                        b_filename = getString("B_FILENAME");
                        b_id = getInt("B_ID");
                        b_ref = getInt("B_REF");
                        b_relevel = getInt("B_RELEVEL");
                        b_restep = getInt("B_RESTEP");
                        b_url = getString("B_URL");
                        print = getSkin(skinPath + "write_form.txt");
                        print = change_Code(print,"[PRINT_TABLE]",table);
                        print = change_Code(print,"[PRINT_WACT]","EEE");
                        print = change_Code(print,"[PRINT_BNAME]",b_name);
                        print = change_Code(print,"[PRINT_BMAIL]",b_mail);
                        print = change_Code(print,"[PRINT_BURL]",b_url);
                        print = change_Code(print,"[PRINT_BTITLE]",b_title);
                        print = change_Code(print,"[PRINT_BPWD]",b_pwd); 
                        print = change_Code(print,"[PRINT_BCONTENT]",b_content);
                        if(fileupload.equals("Y")) {
                            if(!b_filename.equals("")) {
                                print = change_Code(print,"[PRINT_FILEYN]","<input type=hidden name=uploadbox value='Y'> ÷");
                                print = change_Code(print,"[PRINT_WARNFILE]","  : "+b_filename+"<br>Ϸ ٲٸ   ˴ϴ. ");
                                print = change_Code(print,"[PRINT_FILEFORM]","<input type='file' class='box' name='file1' size='25'>");
                            } else {
                                print = change_Code(print,"[PRINT_FILEYN]","<input type=hidden name=uploadbox value='Y'> ÷");
                                print = change_Code(print,"[PRINT_WARNFILE]","");
                                print = change_Code(print,"[PRINT_FILEFORM]","<input type='file' class='box' name='file1' size='25'>");
                            }
                        } else {
                            if(!b_filename.equals("")) {
                                print = change_Code(print,"[PRINT_FILEYN]","<input type=hidden name=uploadbox value='N'>");
                                print = change_Code(print,"[PRINT_WARNFILE]"," ("+b_filename+") ˴ϴ.");
                                print = change_Code(print,"[PRINT_FILEFORM]","");
                            } else {
                                print = change_Code(print,"[PRINT_FILEYN]","<input type=hidden name=uploadbox value='N'>");
                                print = change_Code(print,"[PRINT_WARNFILE]","");
                                print = change_Code(print,"[PRINT_FILEFORM]","");
                            }
                        }
                        print = change_Code(print,"[PRINT_BEFOREFILENAME]",b_filename);
                        print = change_Code(print,"[PRINT_BID]",""+b_id);
                        if(isAdmin() || getParam("password").equals(adminPwd)) {
                            print = change_Code(print,"[PRINT_BPWD]",b_pwd);
                        }
                        print = change_Code(print,"[PRINT_BREF]",""+b_ref);
                        print = change_Code(print,"[PRINT_BRELEVEL]",""+b_relevel);
                        print = change_Code(print,"[PRINT_BRESTEP]",""+b_restep);
                        print = change_Code(print,"[PRINT_OLDPWD]",getParam("password"));
                        print = change_Code(print,"[PRINT_WACT]","EEE");
                        print = change_Code(print,"[PRINT_MYPAGE]",getParam("mypage"));
                        print = change_Code(print,"[PRINT_BUTTON]","<a href='javascript:on_editbtn_click();'><img border=0 height=20 src='skin/images/save.gif' width=60></a>");
                    } else { // йȣ ġ 
                        print = backScript("йȣ ġ ʽϴ");
                    }
                } else {
                    throw new KimhoBoardException("شϴ  ϴ.");
                }
            } else if(getParam("WACT").equals("EEE")) {
                fileyn=getParam("fileyn");
                String e = setEdit(); // ߴ  ִ ȣ
                if(e.equals("")) { // йȣ ġ 
                    print = backScript("йȣ ġ ʴ´ٴϱ~"); //Ƿ Ѱ ϴ° 
                } else {
                    //print = getList(e);
                    print = goList(e);
                }
            } else if(getParam("WACT").equals("D") && !isAdmin()) {
                print = getSkin(skinPath + "pwd_confirm.txt");
                print = change_Code(print,"[PRINT_TABLE]",table);
                print = change_Code(print,"[PRINT_BID]",getParam("b_id"));
                print = change_Code(print,"[PRINT_WACT]","DD");
                print = change_Code(print,"[PRINT_MYPAGE]",getParam("mypage"));
                print = change_Code(print,"[PRINT_BFILENAME]",getParam("b_filename"));
            } else if(getParam("WACT").equals("DD") || 
                    (getParam("WACT").equals("D") && isAdmin()) ||
                        (getParam("WACT").equals("DD") && getParam("password").equals(adminPwd))) {
                String e = setDelete(); // ߴ  ִ ȣ
                if(e.equals("")) { // йȣ ġ 
                    print = backScript("йȣ ġ ʴ´ٴϱ~"); //Ƿ Ѱ ϴ° 
                } else {
                    //print = getList(e);
                    print = goList(e);
                }
            }
            return print;
        } catch(Exception e) {
            throw new KimhoBoardException("۾//   ߻߽ϴ. :"+e.toString());
        }
    }

    /** Ʈ  ´ */
    public String getList(String pg) throws KimhoBoardException {
        try {
            sbf = sbf.append(getSkin(skinPath + "head.txt"));

            /* ¡  */
            Paging paging = new Paging(pg.equals("")?"1":pg,pageBlock);


            //˻̸ ¡ ٽ 
            if(getParam("search_yn").equals("Y")) {
                paging.setSearchDataCount(getParam("search_method"),getSearchParam("search_word"));
                sbf.append("<br><center>'"+getSearchParam("search_word")+"'  ˻ </center>");
            }
            /* session ȮϿ    */
            String admin="<a href='kimhoboard.jsp?branch=A&ACT=LOGIN&table="+table+"'><img src='./skin/images/admin.gif' border=0 onMouseOver=\"window.status=('  α');return true;\" onMouseOut=\"window.status=('');return true;\"></a>";
            if(!getAttr("admin").equals("")) {
                String adsession=getAttr("admin");
                if (adsession.equals(ses.getId())) {  //  α ǰ ġϸ
                    admin="<a href='kimhoboard.jsp?branch=A&ACT=LOGOUT&table="+table+"'><img src='./skin/images/logout.gif' border=0 onMouseOver=\"window.status=('  α׾ƿ');return true;\" onMouseOut=\"window.status=('');return true;\"></a>";
                } 
            }

            if(getParam("search_yn").equals("Y")) {  //˻̸
                if(getParam("search_method").equals("b_name") || getParam("search_method").equals("b_title") || getParam("search_method").equals("b_content")) {
                    executeQuery(getSearchListSQL(getParam("search_method"),getSearchParam("search_word")));
                    if(!next()) {  //next() ѹ ȣ
                        msg = "<script language='javascript' src='khscript.js'></script> ";
                        msg = msg + "<body><p><center>˻  ϴ&nbsp;<a href=kimhoboard.jsp?table="+table+">[Ʈ]</a>";
                        sbf = sbf.append(msg);
                        sbf = sbf.append(getSkin(skinPath + "list_search.txt"));
                        sbf = sbf.append("</center>");
                        sbf = sbf.append(getSkin(skinPath + "tail.txt"));
                        return change_Code(sbf.toString(),"[PRINT_TABLE]",table); // ٷ return Ų.
                    }
                }
            } else { // ˻ ƴϸ
                if(db.equals("mysql")) {
                    rsListQuery(SEL_LIST,paging.getAbpage());
                } else if(db.equals("oracle")) {
                    rsListQuery(SEL_LIST_ORACLE,paging.getAbpage());
                } else {
                    rsListQuery(SEL_LIST,paging.getAbpage());
                }
            }
            if (getRs() == null) {
                msg = "<body><p><center> ϴ</center>";
                sbf = sbf.append(msg);
            }

            /* list_head κ */
            list_head = getSkin(skinPath + "list_head.txt");
            list_head = change_Code(list_head,"[PRINT_ADMIN]",admin);
            list_head = change_Code(list_head,"[PRINT_DATACOUNT]",""+paging.getDatacount());
            list_head = change_Code(list_head,"[PRINT_MYPAGE]",""+paging.getMypage());
            list_head = change_Code(list_head,"[PRINT_PAGECOUNT]",""+paging.getPagecount());
            sbf = sbf.append(list_head);                 
            /*    */
            sbf = sbf.append(getSkin(skinPath + "list_main_head.txt"));

            for(int k=1,h=paging.getDatacount()-(paging.getPagesize()*(paging.getMypage()-1));k <= (getRs()!=null?paging.getPagesize():0); k++,h--) { //h ȣ  
                setList();
                list_main = getSkin(skinPath + "list_main.txt");
                list_main = change_Code(list_main,"[PRINT_TABLE]",table);
                list_main = change_Code(list_main,"[PRINT_H]",""+h);
                list_main = change_Code(list_main,"[PRINT_NEWICON]",newicon);
                list_main = change_Code(list_main,"[PRINT_RE]",re);
                list_main = change_Code(list_main,"[PRINT_BID]",""+b_id);
                list_main = change_Code(list_main,"[PRINT_MYPAGE]",getParam("mypage").equals("")?"1":getParam("mypage"));
                list_main = change_Code(list_main,"[PRINT_BTITLE]",b_title);
                list_main = change_Code(list_main,"[PRINT_MAILTOYOU]",mailtoyou);
                list_main = change_Code(list_main,"[PRINT_BDATE]",b_date);
                list_main = change_Code(list_main,"[PRINT_BVIEW]",""+b_view);
                sbf = sbf.append(list_main);
                if(getRow()==paging.getDatacount()){ 
                    break;
                } else {
                    next();
                }
            }

            /* ¡ κ*/
            list_paging = getSkin(skinPath + "list_paging.txt");
            list_paging = change_Code(list_paging,"[PRINT_TOLIST]",getParam("search_yn").equals("Y")?"<a href=kimhoboard.jsp?branch=L&table="+table+">[Ʈ]</a>":"");
            list_paging = change_Code(list_paging,"[PRINT_BEFOREPAGELIST]",paging.getBeforePageList());
            list_paging = change_Code(list_paging,"[PRINT_PAGELIST]",paging.getPageList());
            list_paging = change_Code(list_paging,"[PRINT_NEXTPAGELIST]",paging.getNextPageList());
            list_paging = change_Code(list_paging,"[PRINT_BEFOREPAGE]",paging.getBeforePage());
            list_paging = change_Code(list_paging,"[PRINT_AFTERPAGE]",paging.getAfterPage());
            list_paging = change_Code(list_paging,"[PRINT_TABLE]",table);
            sbf = sbf.append(list_paging);
            
            /* ˻  ׿*/
            sbf = sbf.append(change_Code(getSkin(skinPath + "list_search.txt"),"[PRINT_TABLE]",table));
            sbf = sbf.append(getSkin(skinPath + "list_bottom.txt"));
            sbf = sbf.append(getSkin(skinPath + "tail.txt"));

            return sbf.toString();

        } catch(Exception e) {
            throw new KimhoBoardException("Ʈ    ߻߽ϴ"+e.toString());
        }
    }

    /** Ʈ   ʿ  Ѵ */
	public void setList() throws KimhoBoardException {
        try {
            b_id=getInt("B_ID");
            b_name=getString("B_NAME");
            b_mail=getString("B_MAIL");
            b_title=getString("B_TITLE");
            b_content=getString("B_CONTENT");
            b_date=getString("B_DATE");
            b_view=getInt("B_VIEW");
            b_pwd=getString("B_PWD");

            if(!b_mail.equals("")) {
                    mailtoyou="<a href=mailto:"+b_mail+">"+b_name+"</a>";
            } else {
                    mailtoyou=b_name;
            }

            b_relevel=getInt("B_RELEVEL");

            int wid=0; 
            if(b_relevel>0) {
                wid=b_relevel*7;
                re="<img src=./skin/default/images/re_level.gif width="+wid+" height=5><img src=./skin/default/images/re_icon.gif>";
            } else {
                wid=0;
                re="";
            }
            b_restep=getInt("B_RESTEP");
            if(b_restep>0) {
                b_title="<font color=#8CBBD5>"+b_title+"</font>";
            }

            now=getToday("yyyy-MM-dd");
            if(!getString("B_FILENAME").equals("")) {
                newicon="<img src='./skin/images/fileadd.gif' border=0 alt='"+getString("B_FILESIZE")+"byte'>";
            } else if(now.equals(b_date)) {
                newicon="<img src='./skin/images/new_icon1.gif' border=0>";
            } else {
                newicon="<img src='./skin/images/icon1.gif' border=0>";
            }
        } catch(Exception e) {
            throw new KimhoBoardException("Ʈ ׸ õ  ߻߽ϴ"+e.toString());
        }
	}

    /** ˻  */
    public String getSearchListSQL(String s1, String s2) throws KimhoBoardException {
        try {
            if(db.equals("mysql")) {
                return "SELECT B_ID,B_NAME,B_MAIL,B_TITLE,B_CONTENT,DATE_FORMAT(B_DATE,'%Y-%m-%d') B_DATE,B_VIEW,B_PWD,B_REF,B_RELEVEL,B_RESTEP,B_URL,B_HTML,B_FILENAME,B_FILESIZE FROM "+table+" "
                      + "WHERE "+s1+" LIKE '%"+s2+"%' ORDER BY B_REF DESC, B_RESTEP ASC";
            } else if(db.equals("oracle")) {
                return "SELECT B_ID,B_NAME,B_MAIL,B_TITLE,B_CONTENT,TO_CHAR(B_DATE,'yyyy-mm-dd') B_DATE,B_VIEW,B_PWD,B_REF,B_RELEVEL,B_RESTEP,B_URL,B_HTML,B_FILENAME,B_FILESIZE FROM "+table+" "
                      + "WHERE "+s1+" LIKE '%"+s2+"%' ORDER BY B_REF DESC, B_RESTEP ASC";
            } else {
                return "SELECT B_ID,B_NAME,B_MAIL,B_TITLE,B_CONTENT,DATE_FORMAT(B_DATE,'%Y-%m-%d') B_DATE,B_VIEW,B_PWD,B_REF,B_RELEVEL,B_RESTEP,B_URL,B_HTML,B_FILENAME,B_FILESIZE FROM "+table+" "
                      + "WHERE "+s1+" LIKE '%"+s2+"%' ORDER BY B_REF DESC, B_RESTEP ASC";
            }
        } catch(Exception e) {
            throw new KimhoBoardException("˻   ߻߽ϴ."+e.toString());
        }
    }

    /** ۺ ȭ  */
    public String getView() throws KimhoBoardException {
        try {
            if(db.equals("oracle")) {
                preparedStmt(SEL_DATA_ORACLE); 
            } else {
                preparedStmt(SEL_DATA); 
            }
            pstmt.setString(1,getParam("b_id"));
            pExecuteQuery();
            if(next()) {
                b_id=rs.getInt("B_ID");
                b_name=getString("B_NAME");
                b_mail=getString("B_MAIL");
                    if(!b_mail.equals("")) {
                            b_mail="<font size=2>(<a href=mailto:"+b_mail+">"+b_mail+"</a>)</font>";
                    } else {
                            b_mail="";
                    }
                b_title=getString("B_TITLE");
                b_content=getString("B_CONTENT");

                b_date=getString("B_DATE");

                b_view=getInt("B_VIEW");
                b_pwd=getString("B_PWD");
                b_ref=getInt("B_REF");
                b_relevel=getInt("B_RELEVEL");
                b_restep=getInt("B_RESTEP");
                b_url=(getString("B_URL")).trim();
                if(b_url.equals("") || b_url.equals("http://")) {
                    b_url="";
                } else {
                    b_url="&nbsp;&nbsp;&nbsp;<a href='"+b_url+"' target=_blank><img src='skin/images/homepage.gif' border=0 ></a> <a href='"+b_url+"' target=_blank>"+b_url+"</a>";
                }
                b_html=getString("B_HTML");
                b_filename=getString("B_FILENAME");
                b_filesize=getString("B_FILESIZE");
                if(!b_filesize.equals("")) b_filesize="("+b_filesize+"byte)";
                preparedStmt(UPD_BVIEW); 
                pstmt.setString(1,getParam("b_id"));
                pExecuteUpdate(); // ȸ 
                change_Html(b_html,b_content);
                b_content=change_Code(b_content,"\n","<br>");  // change_Html    change_Code ؾԿ 
            }
            sbf = sbf.append(getSkin(skinPath + "view_head.txt"));            
            view_main = getSkin(skinPath + "view_main.txt");
            view_main = change_Code(view_main,"[PRINT_TABLE]",table);
            view_main = change_Code(view_main,"[PRINT_BTITLE]",b_title);
            view_main = change_Code(view_main,"[PRINT_BNAME]",b_name);
            view_main = change_Code(view_main,"[PRINT_BMAIL]",b_mail);
            view_main = change_Code(view_main,"[PRINT_BURL]",b_url);
            view_main = change_Code(view_main,"[PRINT_BDATE]",b_date);
            view_main = change_Code(view_main,"[PRINT_BVIEW]",""+b_view);
            if(b_filename.equals("")) {
                view_main = change_Code(view_main,"[PRINT_FILE]","");
            } else {
                view_main = change_Code(view_main,"[PRINT_FILE]","<font color='#333399'><a href='upload/[PRINT_BFILENAMEENC]'>[PRINT_BFILENAME]</a>[PRINT_BFILESIZE]</font></font>");
            }
            view_main = change_Code(view_main,"[PRINT_BFILENAMEENC]",java.net.URLEncoder.encode(b_filename));
            view_main = change_Code(view_main,"[PRINT_BFILENAME]",b_filename);
            view_main = change_Code(view_main,"[PRINT_BFILESIZE]",b_filesize);
            view_main = change_Code(view_main,"[PRINT_BCONTENT]",b_content);
            view_main = change_Code(view_main,"[PRINT_BID]",""+b_id);
            view_main = change_Code(view_main,"[PRINT_BREF]",""+b_ref);
            view_main = change_Code(view_main,"[PRINT_BRELEVEL]",""+b_relevel);
            view_main = change_Code(view_main,"[PRINT_BRESTEP]",""+b_restep);
            view_main = change_Code(view_main,"[PRINT_MYPAGE]",getParam("mypage").equals("")?"1":getParam("mypage"));
            sbf = sbf.append(view_main);
            view_tail = getSkin(skinPath + "view_tail.txt");
            view_tail = change_Code(view_tail,"[PRINT_MYPAGE]",getParam("mypage").equals("")?"1":getParam("mypage"));
            view_tail = change_Code(view_tail,"[PRINT_TABLE]",table);

            if(viewList.equals("Y")) {
                view_tail = view_tail + "<p><table border=0 cellpadding=0 cellspacing=0 width='700'>"+getViewList(b_ref,b_id)+"</table>";
            }

            sbf = sbf.append(view_tail);            
            sbf = sbf.append(getSkin(skinPath + "tail.txt"));
            print = sbf.toString();
            return print;
        } catch(Exception e) {
            throw new KimhoBoardException("ۺ ͼ  ߻߽ϴ.:"+e.toString());
        }
    }

    /**   ñ ش */
    public String getViewList(int ref,int id) throws KimhoBoardException {
        try {
            if(db.equals("oracle")) {
                preparedStmt(SEL_VIEWLIST_ORACLE); 
            } else if(db.equals("mysql")) {
                preparedStmt(SEL_VIEWLIST); 
            } else {
                preparedStmt(SEL_VIEWLIST); 
            }
            pstmt.setString(1,""+ref);
            pExecuteQuery();       
            String view_list = "";
            StringBuffer vsbf = new StringBuffer(view_list);
            while(next()) {          
                setList();          
                view_list = getSkin(skinPath + "list_main.txt");
                view_list = change_Code(view_list,"[PRINT_TABLE]",table);
                view_list = change_Code(view_list,"[PRINT_H]",""+b_id);
                view_list = change_Code(view_list,"[PRINT_NEWICON]",newicon);
                view_list = change_Code(view_list,"[PRINT_RE]",re);
                view_list = change_Code(view_list,"[PRINT_BID]",""+b_id);
                view_list = change_Code(view_list,"[PRINT_MYPAGE]",getParam("mypage").equals("")?"1":getParam("mypage"));
                view_list = change_Code(view_list,"[PRINT_BTITLE]",(b_id==id)?"<b>"+b_title+"</b>":b_title);
                view_list = change_Code(view_list,"[PRINT_MAILTOYOU]",mailtoyou);
                view_list = change_Code(view_list,"[PRINT_BDATE]",b_date);
                view_list = change_Code(view_list,"[PRINT_BVIEW]",""+b_view);
                vsbf = vsbf.append(view_list);
            }         
            return vsbf.toString();
        } catch(Exception e) {
            throw new KimhoBoardException("ۺ ñ ͼ  ߻߽ϴ.:"+e.toString());
        }
    }

    /**  μ */
    public void setInsert() throws KimhoBoardException {
        try {
            executeQuery(SEL_MAX_BID);
            if(next()) {
                b_id=getInt(1);  //  ū  ȣ -  ȣ  ȣ Է ̴.
                b_id=b_id+1;
                maxref=getInt(2);
            } else {
                b_id=1;   // ƹ ͵  ʱ ̸ ۹ȣ 1 ִ´.
            }
            if(!getParam("b_id").equals("")) { // 亯  ̸
                preparedStmt(UPD_REPLY);
                pstmt.setString(1,getParam("b_ref"));
                pstmt.setString(2,getParam("b_restep"));
                pExecuteUpdate();
                b_ref=Integer.parseInt(getParam("b_ref"));
                b_restep=Integer.parseInt(getParam("b_restep"))+1;
                b_relevel=Integer.parseInt(getParam("b_relevel"))+1;
            } else {
                b_ref=maxref+1;
                b_restep=0;
                b_relevel=0;
            }
            if(db.equals("mysql")) {
                preparedStmt(INS_DATA); // INSERT 
            } else if (db.equals("oracle")) {
                preparedStmt(INS_DATA_ORACLE); // INSERT 
            }
            pstmt.setString(1,""+b_id);
            pstmt.setString(2,change_Text(getParam("b_name")));
            pstmt.setString(3,change_Text(getParam("b_mail")));
            pstmt.setString(4,change_Text(getParam("b_title").trim().equals("")?"()":getParam("b_title")));
            pstmt.setString(5,getParam("b_content"));
            if(db.equals("mysql")) {
                pstmt.setString(6,change_Text(getParam("b_pwd")));
            } else if (db.equals("oracle")) {
                pstmt.setString(6,change_Text(getParam("b_pwd")));
            }
            pstmt.setString(7,""+b_ref);
            pstmt.setString(8,""+b_relevel);
            pstmt.setString(9,""+b_restep);
            pstmt.setString(10,change_Text(getParam("b_url")));
            pstmt.setString(11,getParam("b_html"));
            pstmt.setString(12,change_Text(getParam("b_filename")));
            pstmt.setString(13,getParam("b_filesize"));
            pExecuteUpdate();
        }
        catch (Exception e) {
            throw new KimhoBoardException("    ߻߽ϴ.:"+e.toString());  
        }
    }

    /**  μ */
    public String setEdit() throws KimhoBoardException {
        try {
            if(!getParam("beforefilename").equals("")) {  //    Ѵ.
                File f=new File(uploadPath,urlDec(getParam("beforefilename")));
                if(f.exists()) {
                    f.delete();
                }
            }

            preparedStmt(SEL_DATA);
            pstmt.setString(1,getParam("b_id"));
            pExecuteQuery();
            if(next()) {
                b_pwd = getString("B_PWD");
                if(b_pwd.equals(getParam("oldpwd")) || isAdmin() || getParam("oldpwd").equals(adminPwd)) {
                    preparedStmt(UPD_DATA); // ۼ
                    pstmt.setString(1,change_Text(getParam("b_name")));
                    pstmt.setString(2,change_Text(getParam("b_mail")));
                    pstmt.setString(3,change_Text(getParam("b_title").trim().equals("")?"()":getParam("b_title")));
                    pstmt.setString(4,getParam("b_content"));
                    pstmt.setString(5,change_Text(getParam("b_pwd")));
                    pstmt.setString(6,change_Text(getParam("b_url")));
                    pstmt.setString(7,getParam("b_html"));
                    pstmt.setString(8,change_Text(getParam("b_filename")));
                    pstmt.setString(9,getParam("b_filesize"));
                    pstmt.setString(10,getParam("b_id"));
                    pExecuteUpdate();
                    return getParam("mypage"); // ۼߴ   ȣ ̵Ѵ.
                } else { // йȣ ġ 
                    return "";
                }
            } else {
                throw new KimhoBoardException("ش   ʽϴ.");
            }
        } catch(Exception e) {
            throw new KimhoBoardException("    ߻߽ϴ.:"+e.toString());
        }
    }

    /**  μ */
    public String setDelete() throws KimhoBoardException {
        try {
            File file=new File(uploadPath,getParam("b_filename"));
			if(file.exists()) {
				file.delete();
			} 

            preparedStmt(SEL_DATA);
            pstmt.setString(1,getParam("b_id"));
            pExecuteQuery();
            if(next()) {
                b_pwd = getString("B_PWD");
                if(b_pwd.equals(getParam("password")) || getParam("password").equals(adminPwd) || isAdmin()) {
                    preparedStmt(DEL_DATA); // ۻ
                    pstmt.setString(1,getParam("b_id"));
                    pExecuteUpdate();
                    return getParam("mypage"); // ۻߴ   ȣ ̵Ѵ.
                } else { // йȣ ġ 
                    return "";
                }
            } else {
                throw new KimhoBoardException("ش   ʽϴ.");
            }
        } catch(Exception e) {
            throw new KimhoBoardException("    ߻߽ϴ.:"+e.toString());
        }
    }

	/** Ʈ  ̵Ѵ (μ  ޼ҵ  ϱ Ѵ */
	public String goList(String pg) {
		return "<script laguage=javascript> "
				+ " document.location.href='kimhoboard.jsp?table="+table+"&mypage="+pg+"';"
				+ " </script> ";
	}

    /**  Ȯ */
    public boolean isAdmin() {
        if(getAttr("admin").equals(ses.getId())) {
            return true;
        } else {
            return false;
        }
    }

    /** ŲϷ  оδ */
    public String getSkin(String str) throws KimhoBoardException {
        try {
            String s="";
            String inputFileName = str;
            File inputFile = new File(inputFileName);
            FileInputStream in = new FileInputStream(inputFile);
            byte bt[] = new byte[(int)inputFile.length()];
            in.read(bt);
            s = new String(bt);
            in.close();
            return s;
        } catch(IOException ioe) {
            throw new KimhoBoardException("Ų   ϴ.("+str+"):"+ioe.toString());
        }
    }

    /** Ķ͸ ޴´ */
    public String getParam(String str) throws KimhoBoardException {
        try {
            if(req.getParameter(str)==null) {
                return "";
            } else {
                if(fileyn.equals("Y")) {
                    return urlDec(req.getParameter(str));
                } else {
                    return toEuckr(req.getParameter(str));
                }
            }
        } catch(Exception e) {
            throw new KimhoBoardException("Ķ ȯ  ߻߽ϴ.: "+e.toString());
        }
    }

    /** ˻ Ķ͸ ޴´. URL Decoding  */
    public String getSearchParam(String str) throws KimhoBoardException {
        try {
            if(req.getParameter(str)==null) {
                return "";
            } else {
                return urlDec(req.getParameter(str));
            }
        } catch(Exception e) {
            throw new KimhoBoardException("˻ Ķ ȯ  ߻߽ϴ.: "+e.toString());
        }
    }

    /** ǰ ´ */
    public String getAttr(String str) {
        if(ses.getAttribute(str)==null) {
            return "";
        } else {
            return (String)ses.getAttribute(str);
        }
    }

    /** ѱ ڵ ȯ */
	public String toEuckr(String str) throws KimhoBoardException {
        try { 
            if(str!=null) {
                str=new String(str.getBytes("8859_1"),"euc-kr");
            } else str="";
            return str;
        } catch(UnsupportedEncodingException uee) {
            throw new KimhoBoardException("ѱ ȯ  ߻߽ϴ"+uee.toString());
        }
	}

    /** ڿ ٲٴ ޼ҵ */
    public String change_Code(String line, String oldString, String newString) {
	    for(int index = 0; (index = line.indexOf(oldString, index)) >= 0; index += newString.length())
			line = line.substring(0, index) + newString + line.substring(index + oldString.length());
		return line;
	}

	/** ϴ ¥   ¥  ޼ҵ */
	private String getToday(String format) {
		java.util.Date mydate = new java.util.Date();
		SimpleDateFormat mytoday = new SimpleDateFormat(format);
		String today=mytoday.format(mydate);  
		return today;
	}

    /** HTML  ȯϴ ޼ҵ */
    public void change_Html(String html,String content) {
		if(html.equals("T")) {
			content=change_Code(content,"<","&lt;");
			content=change_Code(content,">","&gt;");
			b_content=content;
		} else if (html.equals("H")) {
			content=change_Code(content,"&lt;","<");
			content=change_Code(content,"&gt;",">");
			b_content=content;
		}
	}

    /** HTML TEXT  ȯϴ ޼ҵ 
     *  b_content ٸ ͵  TEXT Ų.
    */
    public String change_Text(String str) {
		str=change_Code(str,"<","&lt;");
		str=change_Code(str,">","&gt;");
        return str;
	}

    /** URL Decoding Ѵ */
    public String urlDec(String str) {
        return java.net.URLDecoder.decode(str);
    }

    public String backScript(String str) {
        return "<script language=javascript> alert('"+str+"'); history.go(-1); </script>";
    }

    public String hexToStr(String str) {
        return "";
    }

    /* Paging Ŭ  */
    class Paging {
        private int datacount=0;      //  ۼ
        private int pagecount;        //   
        private int pagesize=Integer.parseInt(pageSize);      //    ۼ
        protected int mypage=1;         //  
        private int abpage=1;         // Ʈ ̵ ο ȣ
        private int plistblock=5;     //      . Ʈ 5
        private int plistblockno=1;   //   ȣ
        private int plistfirst=1;     //    ù°  ȣ
        private int plistlast=1;      //      ȣ

        private String search_yn="N";
        private String search_method="";
        private String search_word="";

        /**  */
        public Paging(String mp,String plum) throws KimhoBoardException, IOException {
            try { 
                plistblock=Integer.parseInt(plum);   //     ΰ 
                setDatacount(stmt);
                setPagecount();
                setMypage(mp);
                setAbpage();
            } catch(SQLException sqle) {
                throw new KimhoBoardException("¡   ߻߽ϴ."+sqle.toString());
            }
        }

        public void setDatacount(Statement stmt) throws SQLException, IOException {
            executeQuery("select count(b_id) from "+table);
            if(next()) {
                this.datacount=getInt(1);  // ۼ
            }
        }

        /** ˻϶   */
        public void setSearchDataCount(String search_method,String search_word) throws KimhoBoardException {
            try { 
                this.search_yn="Y";
                this.search_method=search_method;
                this.search_word=search_word;
                String sql = "select count(b_id) from "+table+" where "+search_method+" like '%"+search_word+"%'";
                ResultSet rs0=stmt.executeQuery(sql);
                if(rs0.next()) {
                    this.datacount=rs0.getInt(1);  // ۼ
                    rs0.close();
                }
                setPagecount();
                setAbpage();
            } catch(SQLException sqle) {
                throw new KimhoBoardException("˻     ߻߽ϴ"+sqle.toString());
            }
        }

        /**    ϱ */
        public void setPagecount() {
            if(this.datacount%this.pagesize !=0) 
                this.pagecount=this.datacount/this.pagesize+1; 
            else this.pagecount=this.datacount/this.pagesize;
        }

        /**  int */
        public void setMypage(String mp) {
            this.mypage=Integer.parseInt(mp);
        }

        /** absolute()  ù ۹ȣ*/
        public void setAbpage() {
            this.abpage=(this.mypage-1)*this.pagesize+1;
            if(this.abpage <= 0 ) this.abpage=1; 
        }

        public int getDatacount() {
            return datacount;
        }

        public int getPagecount() {
            return pagecount;
        }

        public int getPagesize() {
            return pagesize;
        }

        public int getMypage() {
            return mypage;
        }

        public int getAbpage() {
            return abpage;
        }

        public String getBeforePage() {
            int gopage;
            if(this.mypage!=1) {
                gopage=mypage-1;
                return "<a href='kimhoboard.jsp?mypage="+gopage+"&search_method="+this.search_method+"&search_word="+this.search_word+"&search_yn="+this.search_yn+"&table="+table+"' title='' onmouseover=\"window.status=(' ');return true;\" onmouseout=\"window.status=('');return true;\"><img border=0 src=\"skin/images/pre.gif\" width=57></a>";
            } else {
                return "<a href='#' title=' ù Դϴ.' onmouseover=\"window.status=('  ');return true;\" onmouseout=\"window.status=('');return true;\"><img border=0 src=\"skin/images/pre.gif\" width=57></a>";
            }
        }

        public String getAfterPage() {
            int gopage;
            if(this.mypage!=this.pagecount) {
            gopage=this.mypage+1;
                return "<a href='kimhoboard.jsp?mypage="+gopage+"&search_method="+this.search_method+"&search_word="+this.search_word+"&search_yn="+this.search_yn+"&table="+table+"' title='' onmouseover=\"window.status=(' ');return true;\" onmouseout=\"window.status=('');return true;\"><img border=0 src=\"skin/images/next.gif\" width=57></a>";
            } else {
                return "<a href='#' title='  Դϴ.' onmouseover=\"window.status=('  ');return true;\" onmouseout=\"window.status=('');return true;\"><img border=0 src=\"skin/images/next.gif\" width=57></a>";
            }
        }

        // getBeforePageList() getPageList() getNextPageList()   Ǿ Ѵ. 
        public String getBeforePageList() {

            if(this.mypage%this.plistblock==0) this.plistblockno=this.mypage/this.plistblock;	//    ȣ
            else this.plistblockno=this.mypage/this.plistblock+1;								// Ѵ.
            this.plistfirst=1+((this.plistblockno-1)*this.plistblock);      //    ù ȣ Ѵ.

            if(this.plistfirst > this.plistblock) {
                StringBuffer data=new StringBuffer();
                int gobefore=this.plistfirst-1;
                data.append("<a href='kimhoboard.jsp?mypage="+gobefore+"&search_method="+this.search_method+"&search_word="+this.search_word+"&search_yn="+this.search_yn+"&table="+table+"' onMouseOver=\"window.status=(' "+this.plistblock+" ̵մϴ.');return true;\" onMouseOut=\"window.status=('');return true;\"></a>");
                return data.toString();
            }
            else {
                return "";
            }
        }

        public String getPageList() {
            this.plistlast=this.plistfirst+(this.plistblock-1);					//     ȣ
            if(this.plistlast >= this.pagecount) this.plistlast=this.pagecount;	// Ѵ.
            StringBuffer data=new StringBuffer();

            for(int pnum=this.plistfirst;pnum <= this.plistlast;pnum++) {    //  ù   .
                    if(pnum==this.mypage) data.append("<b>");
                    data.append("<a href='kimhoboard.jsp?mypage="+pnum+"&search_method="+this.search_method+"&search_word="+this.search_word+"&search_yn="+this.search_yn+"&table="+table+"' onMouseOver=\"window.status=('"+pnum+" ̵մϴ.');return true;\" onMouseOut=\"window.status=('');return true;\">["+pnum+"]</a>&nbsp;"); 
                    if(pnum==this.mypage) data.append("</b>");
            } 
            return data.toString();
        }

        public String getNextPageList() {
            if(this.pagecount > this.plistlast) {
                StringBuffer data=new StringBuffer();
                int gonext=this.plistlast+1;
                data.append("<a href='kimhoboard.jsp?mypage="+gonext+"&search_method="+this.search_method+"&search_word="+this.search_word+"&search_yn="+this.search_yn+"&table="+table+"' onMouseOver=\"window.status=(' "+this.plistblock+" ̵մϴ.');return true;\" onMouseOut=\"window.status=('');return true;\"></a>");
                return data.toString();
            }
            else {
                return "";
            }
        }
    }
    /* Paging Ŭ  */
}

class KimhoBoardException extends Exception {
    String err = "";
	KimhoBoardException(String str) {
        err = str;
		System.out.println(str+"\n");
	}

    public String toString() {
        return "KimhoBoardException"+err;
    }
}